﻿local VERSION = tonumber(("$Revision: 31969 $"):match("%d+"))

local QuestsFu = QuestsFu
local QuestsFu_Blizz = QuestsFu:NewModule("Blizz", "AceEvent-2.0", "AceHook-2.1", "AceConsole-2.0")
if QuestsFu.revision < VERSION then
	QuestsFu.version = "r" .. VERSION
	QuestsFu.revision = VERSION
	QuestsFu.date = ("$Date: 2007-04-06 05:59:51 -0400 (Fri, 06 Apr 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end

local quixote = AceLibrary("Quixote-1.0")

local L = AceLibrary("AceLocale-2.2"):new("QuestsFu_Blizz")
L:RegisterTranslations("enUS", function() return {
	["Blizzard frames"] = true,
	["Improvements to the default UI"] = true,

	["Quest levels"] = true,
	["Show quest levels in the quest log and NPC dialogs"] = true,
	["Quest log"] = true,
	["Add levels to the quest log"] = true,
	["NPC dialogs"] = true,
	["Add levels to NPC dialogs"] = true,
	["LFG"] = true,
	["Add levels to quests in the LFG tool"] = true,

	["Double-width quest log"] = true,
	["Move the details frame from the bottom of the quest log to a new panel on its right side"] = true,
} end)

L:RegisterTranslations("deDE", function() return {
	["Blizzard frames"] = "Blizzard-Fenster",
	["Improvements to the default UI"] = "Verbesserungen für die Blizzard UI.",

	["Quest levels"] = "Quest-Level",
	["Show quest levels in the quest log and NPC dialogs"] = "Zeige die Questlevel im Quest-Log und bei NPC Dialogen",
	["Quest log"] = "Quest-Log",
	["Add levels to the quest log"] = "Levelangabe zum Quest-Log hinzufügen.",
	["NPC dialogs"] = "NPC Dialoge",
	["Add levels to NPC dialogs"] = "Levelangabe zu NPC Dialogen hinzufügen.",
	["LFG"] = "LFG",
	["Add levels to quests in the LFG tool"] = "Levelangabe bei der Suche Nach Gruppe Funktion hinzufügen.",

	["Double-width quest log"] = "Doppelte-Breite Questlog",
	["Move the details frame from the bottom of the quest log to a new panel on its right side"] = "Verschiebe das Quest Detail Fenster vom unteren Ende der Quest zu einem neuen Fenster auf der rechten Seite.",
} end)

L:RegisterTranslations("koKR", function() return {
	["Blizzard frames"] = "블리자드 프레임",
	["Improvements to the default UI"] = "기본 UI에 기능을 추가합니다.",

	["Quest levels"] = "퀘스트 레벨",
	["Show quest levels in the quest log and NPC dialogs"] = "퀘스트 내용과 NPC와 대화시 퀘스트 레벨을 표시합니다.",
	["Quest log"] = "퀘스트 내용",
	["Add levels to the quest log"] = "퀘스트 내용에 레벨을 추가합니다.",
	["NPC dialogs"] = "NPC 대화",
	["Add levels to NPC dialogs"] = "NPC 대화에 레벨을 추가합니다.",
	["LFG"] = "LFG",
	["Add levels to quests in the LFG tool"] = "LFG 도구에 퀘스트 레벨을 추가합니다.",

	["Double-width quest log"] = "오른쪽 퀘스트 내용",
	["Move the details frame from the bottom of the quest log to a new panel on its right side"] = "하단 부분에 표시되는 퀘스트의 내용을 오른쪽에 새로운 패널로 표시합니다.",
} end)

L:RegisterTranslations("zhTW", function() return {
	["Blizzard frames"] = "Blizzard預設框",
	["Improvements to the default UI"] = "改善Blizzard預設UI",
	
	["Quest levels"] = "任務等級",
	["Show quest levels in the quest log and NPC dialogs"] = "在任務紀錄和NPC對話中顯示任務等級",
	["Quest log"] = "任務紀錄",
	["Add levels to the quest log"] = "在任務紀錄中顯示任務等級",
	["NPC dialogs"] = "NPC對話",
	["Add levels to NPC dialogs"] = "在NPC對話中顯示等級",
	["LFG"] = "找隊幫手",
	["Add levels to quests in the LFG tool"] = "在找隊幫手中顯示任務等級",
	
	["Double-width quest log"] = "加寬任務紀錄",
	["Move the details frame from the bottom of the quest log to a new panel on its right side"] = "將任務詳述從任務紀錄框架底部移到原本框架的右邊",
} end)

L:RegisterTranslations("esES", function() return {
	["Blizzard frames"] = "Marcos de Blizzard",
	["Improvements to the default UI"] = "Mejoras a la interfaz por defecto",
	
	["Quest levels"] = "Niveles de misiones",
	["Show quest levels in the quest log and NPC dialogs"] = "Muestra los niveles de las misiones en el registro de misiones y en los diálogos con PNJs",
	["Quest log"] = "Registro de misiones",
	["Add levels to the quest log"] = "Añade los niveles al registro de misiones",
	["NPC dialogs"] = "Diálogos con PNJs",
	["Add levels to NPC dialogs"] = "Añade los niveles a los diálogos con PNJs",
	["LFG"] = "LFG",
	["Add levels to quests in the LFG tool"] = "Añade los niveles de las misiones a la herramienta de Buscar grupo",
	
	["Double-width quest log"] = "Registro de misiones doble de ancho",
	["Move the details frame from the bottom of the quest log to a new panel on its right side"] = "Pone el marco de detalles de la parte baja del registro de misiones en un nuevo panel situado a la derecha",
} end)

function QuestsFu_Blizz:OnInitialize()
	self.db = QuestsFu:AcquireDBNamespace("Blizz")
	QuestsFu:RegisterDefaults("Blizz", "profile", {
		levels = {
			log = true,
			dialog = true,
			lfg = true,
		},
		doublewide = true,
	})
	QuestsFu.options.args.Blizz = {
		name = L["Blizzard frames"],
		desc = L["Improvements to the default UI"],
		type = "group",
		args = {
			levels = {
				name = L["Quest levels"],
				desc = L["Show quest levels in the quest log and NPC dialogs"],
				type = 'group',
				args = {
					log = {
						name = L["Quest log"],
						desc = L["Add levels to the quest log"],
						type = 'toggle',
						get = function() return self.db.profile.levels.log end,
						set = function(t)
							self.db.profile.levels.log = t
							self:UpdateLevelsHooks()
						end,
					},
					dialog = {
						name = L["NPC dialogs"],
						desc = L["Add levels to NPC dialogs"],
						type = 'toggle',
						get = function() return self.db.profile.levels.dialog end,
						set = function(t)
							self.db.profile.levels.dialog = t
							self:UpdateLevelsHooks()
						end,
					},
					lfg = {
						name = L["LFG"],
						desc = L["Add levels to quests in the LFG tool"],
						type = 'toggle',
						get = function() return self.db.profile.levels.lfg end,
						set = function(t)
							self.db.profile.levels.lfg = t
							self:UpdateLevelsHooks()
						end,
						disabled = true,
					},
				},
			},
			doublewide = {
				name = L["Double-width quest log"],
				desc = L["Move the details frame from the bottom of the quest log to a new panel on its right side"],
				type = 'toggle',
				get = function() return self.db.profile.doublewide end,
				set = function(t) self.db.profile.doublewide = t end,
				disabled = true,
			},
			toggle = {
				name = AceLibrary("AceLocale-2.2"):new("QuestsFu")["Enabled"],
				desc = AceLibrary("AceLocale-2.2"):new("QuestsFu")["Suspend/resume this module."],
				type = 'toggle',
				order = -1,
				get = function() return QuestsFu:IsModuleActive(self) end,
				set = function() QuestsFu:ToggleModuleActive(self) end,
			},
		},
	}
end

function QuestsFu_Blizz:OnEnable()
	self:UpdateLevelsHooks()
end

function QuestsFu_Blizz:UpdateLevelsHooks()
	-- In quest log
	if self.db.profile.levels.log then
		if not self:IsHooked("QuestLog_Update") then
			self:SecureHook("QuestLog_Update")
		end
	else
		if self:IsHooked("QuestLog_Update") then
			self:Unhook("QuestLog_Update")
		end
	end
	-- In dialogs
	if self.db.profile.levels.dialog then
		if not self:IsEventRegistered("GOSSIP_SHOW") then
			self:RegisterEvent("GOSSIP_SHOW")
			self:RegisterEvent("QUEST_GREETING")
		end
	else
		if self:IsEventRegistered("GOSSIP_SHOW") then
			self:UnregisterEvent("GOSSIP_SHOW")
			self:UnregisterEvent("QUEST_GREETING")
		end
	end
	--[[
	-- In lfg
	if self.db.profile.levels.log then
		if not self:IsHooked("GetLFGTypeEntries") then
			self:Hook("GetLFGTypeEntries", true)
		end
	else
		if self:IsHooked("GetLFGTypeEntries") then
			self:Unhook("GetLFGTypeEntries")
		end
	end
	--]]
end

----------------------------------------------------
-- Add quest levels to the quest log
----------------------------------------------------

function QuestsFu_Blizz:QuestLog_Update()
	--This is fragile, but lets us ignore event sequencing.  It'll break if anyone is meddling with the output of GetQuestLogTitle.
	--(questIndexes can change on every QUEST_LOG_UPDATE; this *will* be called before Quixote updates from that event, because Quixote is
	--throttling to avoid crashing the client on edge cases. I blame Blizzard for it being possible to crash the game by scanning the quest log. So.)
	for i = 1, QUESTS_DISPLAYED, 1 do
		--local questIndex = i + FauxScrollFrame_GetOffset(QuestLogListScrollFrame)
		local titleLine = _G["QuestLogTitle"..i]
		if titleLine and titleLine:GetText() then
			local title, level, tag = quixote:GetQuest(titleLine:GetText():trim())
			if title then
				titleLine:SetText(QuestsFu:MakeTag(level, tag)..title)
				local check = _G["QuestLogTitle" .. i .. "Check"]
				if check:IsVisible() then
					check:SetPoint("LEFT", titleLine, "LEFT", QuestLogDummyText:GetWidth() + 24, 0)
				end
			end
		end
	end
end

----------------------------------------------------
-- Add quest levels to LFG
----------------------------------------------------

--[[
-- Fuck you, Blizzard. ~vhaarr
function QuestsFu_Blizz:GetLFGTypeEntries(index)
	if index and tonumber(index) then
		index = tonumber(index)
		local original = {self.hooks["GetLFGTypeEntries"](index)}
		for i, v in ipairs(original) do
			if index == 2 or index == 3 or index == 5 then
				if (index == 5 and tourist:IsZone(v)) or tourist:IsInstance(v) then
					local low, high = tourist:GetLevel(v)
					if low and high then
						original[i] = v .. " ("..tostring(low).."-"..tostring(high)..")"
					end
				end
			elseif index == 4 then
				local _, level = quixote:GetQuestByName(v)
				if level and tonumber(level) then
					original[i] = "["..tostring(level).."] "..v
				end
			end
		end
		return unpack(original)
	end
	return self.hooks["GetLFGTypeEntries"](index)
end
]]

----------------------------------------------------
-- Add quest levels to NPC dialog when possible
----------------------------------------------------

--This is pretty much how Minimalist does it, which it credits to AutoSelect.
function QuestsFu_Blizz:GOSSIP_SHOW()
	local buttonindex = 1
	local list, button
	if GetGossipAvailableQuests() then
		list = {GetGossipAvailableQuests()}
		for i = 2,getn(list),2 do
			button = _G["GossipTitleButton"..buttonindex]
			button:SetText(format('[%d] %s',list[i],list[i-1]))
			buttonindex = buttonindex + 1
		end
		buttonindex = buttonindex + 1
		for k in pairs(list) do
			list[k] = nil
		end
	end
	if GetGossipActiveQuests() then
		list = {GetGossipActiveQuests()}
		for i = 2,getn(list),2 do
			button = _G["GossipTitleButton"..buttonindex]
			button:SetText(format('[%d] %s',list[i],list[i-1]))
			buttonindex = buttonindex + 1
		end
		for k in pairs(list) do
			list[k] = nil
		end
	end
end

--This is pretty much how Minimalist does it, which it credits to AutoSelect.
function QuestsFu_Blizz:QUEST_GREETING()
	local numactive,numavailable = GetNumActiveQuests(), GetNumAvailableQuests()
	local title, level, button
	local o,GetTitle,GetLevel = 0,GetActiveTitle,GetActiveLevel
	for i=1, numactive + numavailable do
		if i == numactive + 1 then
			o,GetTitle,GetLevel = numactive,GetAvailableTitle,GetAvailableLevel
		end
		title,level = GetTitle(i-o), GetLevel(i-o)
		button = _G["QuestTitleButton"..i]
		button:SetText(format('[%d] %s',level,title))
	end
end
